//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>  // for sin() and cos() functions
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

        const grid[12][12] = {
	        9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1,
        	1, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 9,
        	9, 0, 0, 10, 0, 0, 0, 0, 0, 12, 0, 1,
	        1, 0, 10, 2, 0, 0, 0, 0, 0, 4, 0, 9,
        	9, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 1,
	        1, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 9,
        	9, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 1,
	        1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
	        9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
                1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
        	9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
	        1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9
        };

	long istable[1800],
		ictable[1800],
		istable2[1800],
		ictable2[1800],
		hht[1200];

	long px=150000,
		py=150000,
		newpx, newpy,
		stepx, stepy;

	int i,
		stride2=3,
		heading=980,
		turn=30;

	double angle,factor=0.003490658;

	char *pxx, *pyy;

	long x1, y1,
		xx, yy,
		xg, yg;

        HDC DC;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

/*void putpixel(int x, int y, int col)
{
        Form1->Canvas->Pixels[x][y] = col; // too slow!
}*/

//---------------------------------------------------------------------------

void computeview()
{
	long a;		//angolo visuale
	int k= 0;	//posizione mappa
	long l;       	//distanza
	int mx=0;

//	for (y1=0;y1<200;y1++) for (x1=0;x1<320;x1++) SetPixel(DC, x1, y1, 0); //putpixel(x1 ,y1, clBtnFace);
        Form1->Canvas->FillRect(Rect(0,0,320,200));

	for (a=heading+160;a>heading-160;a=a-1)
	{
		xx=px;
		yy=py;
		l=0;
		stepx=istable[(a+1800)%1799];
		stepy=ictable[(a+1800)%1799];
		do
		{
			xx=xx-stepx;
			yy=yy-stepy;
			l=l+2;
			k=grid[*(pxx+2)][*(pyy+2)];
		}
		while (k==0);
		/*for (i=99-hht[l]-1;i<=100+hht[l];i++)    // too slow!
			SetPixel(DC, mx, i, k<<5); //putpixel(mx, i, 33+k);*/
                Form1->Canvas->Pen->Color = k<<5;
                Form1->Canvas->MoveTo(mx, 99-hht[l]-1);
                Form1->Canvas->LineTo(mx, 100+hht[l]);

		mx=mx+1;
	}
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        DC = GetDC(Handle);

	pxx=(char*)&xx;
	pyy=(char*)&yy;

	for (i=0;i<1200;i++) if ((hht[i]=((-3000+(64*150))/(i+1))/3)>80) hht[i]=80;

	for (i=0;i<1799;i++)
	{
		angle=i*factor;
		istable[i]=(sin(angle)*0.1*65535)/5;
		ictable[i]=(cos(angle)*0.1*65535)/5;
		istable2[i]=(sin(angle)*0.1*65535)*stride2;
		ictable2[i]=(cos(angle)*0.1*65535)*stride2;
	}

        computeview();
	switch (Key)
	{
		case 37: //left
			heading = (heading + turn) % 1800;
			computeview();
		break;
		case 39: //right
			heading = (heading + (1800 - turn)) % 1800;
			computeview();
		break;
		case 38: //up
			newpx = px - (istable2[heading]);
			newpy = py - (ictable2[heading]);
			if (grid[newpx / 65535][newpy / 65535] == 0)
			{
				px = newpx;
				py = newpy;
				computeview();
			}
		break;
		case 40: //down
			newpx = px + (istable2[heading]);
			newpy = py + (ictable2[heading]);
			if (grid[newpx / 65535][newpy / 65535] == 0)
			{
				px = newpx;
				py = newpy;
				computeview();
			}
		break;
	}
        if (Key==27)
                Form1->Close();

}
//---------------------------------------------------------------------------

