#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>



int world[12][12]={{1,1,1,1,1,1,1,1,1,1,1,1},
		   {1,0,0,0,0,0,0,0,0,0,0,1},
		   {1,0,0,0,0,0,0,0,0,0,0,1},
		   {1,0,0,0,0,0,0,0,0,0,0,1},
		   {1,0,0,0,0,0,0,0,1,0,0,1},
		   {1,0,0,0,0,0,0,0,1,0,0,1},
		   {1,0,0,0,0,0,1,1,1,0,0,1},
		   {1,0,0,0,0,0,0,0,1,0,0,1},
		   {1,0,1,1,0,0,0,0,1,0,0,1},
		   {1,0,0,1,0,0,0,0,0,0,0,1},
		   {1,0,0,1,0,0,0,0,0,0,0,1},
		   {1,1,1,1,1,1,1,1,1,1,1,1}};
int hor[11][12];
int ver[12][11];
long cosp[1260],sinp[1260],tanp[1260];
int fl=256;

void DrawRect(int x,int y,int col)
{
for(int a=0;a<15;a++)
{
for(int b=0;b<15;b++)
Putpixel(x+a,y+b,col,vga);
}
}

unsigned char far image[16384];

int Readpcx (char *name)
{
   FILE *dataFile = fopen (name, "rb");
   unsigned char color, r, g, b, counter, length;
   unsigned int x, y;

   dataFile = fopen (name, "rb");
   fseek (dataFile, -768, SEEK_END);
   for (x=0; x<256; x++)
     {
     r = fgetc (dataFile); r = r>>2;
     g = fgetc (dataFile); g = g>>2;
     b = fgetc (dataFile); b = b>>2;
     SetPal (x, r, g, b);
     }

   x=0; y=0;
   fseek (dataFile, 128, SEEK_SET);
   while (y <= 127)
      {
      color = fgetc (dataFile);
      if (color < 192)			// uncompressed?
	 {
	 if (x > 127)
	   {
	   x=0; y++;
	   }
	 x++;
	 image[x+y*128]=color;
	 }
      else				// must be compressed
	 {
	 length = color-192;
	 color = fgetc (dataFile);
	 for (counter=0; counter<length; counter++)
	    {
	    if (x > 127)
	      {
	      x=0;
	      y++;
	      }
	    x++;
	    image[x+y*128]=color;
	    }
	 }
      }

   fclose (dataFile);
   //getch();
   return 0;
}

void PrepaTrigo()
{
int m;
for(float a=0;a<420;a+=0.333)
  {
  m=a*3;
  cosp[m]=cos(a*0.01745)*fl;
  if (cosp[m]==0)
    cosp[m]=1;
  sinp[m]=sin(a*0.01745)*fl;
  if (sinp[m]==0)
    sinp[m]=1;
  tanp[m]=tan(a*0.01745)*fl;
  if (tanp[m]==0)
    tanp[m]=1;
  }
}


main()
{
int h,v;
float dist,dist1,dist2;
long ay,ax,ya,xa;
long ax2,ay2,xa2,ya2;
int px=300,py=300;
int ag=240,key,i;
float ang;

PrepaTrigo();
SetVGA();
SetVirtual();
Readpcx("ray1.pcx");

for(v=0;v<11;v++)
  {
  for(h=0;h<12;h++)
    {
    if(world[v][h]!=world[v+1][h])
      hor[v][h]=2;
    else
      hor[v][h]=0;
    }
  }

for(v=0;v<12;v++)
  {
  for(h=0;h<11;h++)
    {
    if(world[v][h]!=world[v][h+1])
      ver[v][h]=2;
    else
      ver[v][h]=0;
    }
  }


do
{
switch(key=getch())
  {
  case 77:
    ag+=20;
    if(ag>1074) ag=2;
    break;
  case 75:
    ag-=20;
    if(ag<9) ag=1077;
    break;
  case 72:
    py-=(15*sinp[ag+90])/fl;
    px+=(15*cosp[ag+90])/fl;
    break;
  case 80:
    py+=(15*sinp[ag+90])/fl;
    px-=(15*cosp[ag+90])/fl;
    break;
  }

Cls(vaddr,0);
ang=ag;
//printf("%d\r",ag);
for(i=0;i<320;i++)
{

ang+=0.5625;

if(cosp[ang]>0)
  {
  ax2=(px/64)*64+64;
  ay2=py+((px-ax2)*tanp[ang])/fl ;
  xa2=64;
  ya2=(-64*tanp[ang])/fl;
  }

if(cosp[ang]<0)
  {
  ax2=(px/64)*64;
  ay2=py+((px-ax2)*tanp[ang])/fl;
  xa2=-64;
  ya2=(64*tanp[ang])/fl;
  }

if(sinp[ang]>0)
  {
  ay=(py/64)*64;
  ax=px+((py-ay)*fl)/tanp[ang];
  ya=-64;
  xa=(64*fl)/tanp[ang];
  }

if(sinp[ang]<0)
  {
  ay=(py/64)*64+64;
  ax=px+((py-ay)*fl)/tanp[ang];
  ya=64;
  xa=(-64*fl)/tanp[ang];
  }


while(ver[ay2/64][ax2/64-1]==0 && ay2>0 && ay2<800)
  {
  ax2+=xa2;
  ay2+=ya2;
  }
dist1=abs(((ax2-px)*fl)/(cosp[ang]));

while(hor[ay/64-1][ax/64]==0 && ax>0 && ax<800)
  {
  ax+=xa;
  ay+=ya;
  }
dist2=abs(((ay-py)*fl)/sinp[ang]);

float u;

if(dist1<dist2)
  {
  dist=dist1;
  //u=ax2;
  u=ay2;
  }
else
  {
  dist=dist2;
  u=ax;
  //v=ay;
  }

dist=(dist*cosp[ag-(ang-90)+1080])/fl;

//if( dist<64) dist=64;

long dify;
int vstep,vv;

vv=0;
dify=(64/dist)*90*2;
vstep=(64<<8)/dify;
vv+=vstep;

for(int ii=100-(64/dist)*90;ii<100+(64/dist)*90;ii++)
{
if(i>0 && i<320)
if(ii>0 && ii<200)
Putpixel(i,ii,image[(u*2)+(vv/150)*128],vaddr);
vv+=vstep;
}

//Putpixel(i,100+(64/dist)*90,2,vaddr);
//Putpixel(i,100-(64/dist)*90,3,vaddr);
}
Flip(vaddr,vga);
}
while(key!=27);
FreeVirtual();
}
